# Instructions to Clone, Patch and Install Max's TemplateFitter as Alternative

## Clone the Repository
Go to an appropriate directory and clone the repository via
```shell
git clone git@github.com:welschma/TemplateFitter.git MaxTemplateFitter
```
if you have an ssh key on `GitHub` or via
```shell
git clone https://github.com/welschma/TemplateFitter MaxTemplateFitter
```
if you don't have one.
The repository will be cloned into the directory `MaxTemplateFitter`,
which is necessary when you have the required `TemplateFitter` installed.

##Patching
First of all, replace the original `setup.py` of the alternative `MaxTemplateFitter` with the one provided here:
```shell
cp <path/to/this/directory>/new_templatefitter_setup.py </path/to/MaxTemplateFitter>/setup.py
```
and then copy the script `apply_max_template_fitter_patch.sh` script provided in this folder
**into the directory `MaxTemplateFitter` into which you cloned the repository** and run it **there**:
```shell
cp <path/to/this/directory>/apply_max_template_fitter_patch.sh </path/to/MaxTemplateFitter>/apply_max_template_fitter_patch.sh
./apply_max_template_fitter_patch.sh
```
This will rename all relevant occurrences of `templatefitter` to `maxtemplatefitter`.

## Installation
Now you can install the package into you `basf2` environment by running
```shell
pip3 install -e ./
```
in the repository directory `MaxTemplateFitter`.

## Testing / Usage of the `MaxTemplateFitter`
The alternative `TemplateFitter` should now be available in `python3` and can be imported for instance via:
```python3
import maxtemplatefitter as tf
```
and listed as `MaxTemplateFitter` when running
```shell
pip3 list
```
in the overview of all installed `python3` packages.
